#include <creaImageIOSystem.h>
#include <creaWx.h>
#include <creaImageIOWxGimmickReaderDialog.h>
#include "vtkMetaImageWriter.h"
#include "vtkMetaImageReader.h"
#include <creaVtkBasicSlicer.h>


//
//#pragma comment(lib, "creaImageIO.lib")
//#pragma comment(lib, "DelayImp.lib")
//
//
//// Tell the linker that my DLL should be delay loaded
////#pragma comment(linker, "/DelayLoad:creaImageIO.Dll")
//
//// Tell the linker that I want to be able to unload my DLL
//#pragma comment(linker, "/Delay:unload")
//

class myApp : public wxApp
{
public:
  bool OnInit( );
  int  OnExit() { return true; }
};

IMPLEMENT_APP(myApp);

CREA_WXMAIN_WITH_CONSOLE

bool myApp::OnInit( )
{
  wxApp::OnInit();
#ifdef __WXGTK__
  //See http://www.wxwindows.org/faqgtk.htm#locale
  setlocale(LC_NUMERIC, "C");
#endif
   wxInitAllImageHandlers();

   creaImageIO::SetGimmickMessageLevel(5);
   creaImageIO::SetGimmickDebugMessageLevel(0);

   int min_dim = GIMMICK_2D_IMAGE_SELECTION;
   int max_dim = GIMMICK_3D_IMAGE_SELECTION;

//EED
//   int output_dim = NATIVE;
   int output_dim = _3D;

   int threads = 1;

 
   creaImageIO::WxGimmickReaderDialog w(
                    0,
                   -1, 
				   "localdatabase_Descriptor.dscp",
				   "Local Database",
                   _T("Select image(s)        - Gimmick! (c) CREATIS-LRMN 2008"),
                   wxDefaultPosition,
                   wxSize(810,750),
                   min_dim,
                   max_dim,
                   output_dim,
       
				   threads);
  /* clock_t endwait;
		endwait = clock () +  CLOCKS_PER_SEC ;
		while (clock() < endwait ) {}*/
   w.ShowModal();

   if (w.GetReturnCode() == wxID_OK)
     {
       std::cout << "$$$$ main : user clicked 'OK' $$$$"<<std::endl;
       std::cout << "$$$$ selected files : "<<std::endl;
       //Puts filenames
       std::vector<std::string> s;
       w.GetSelectedFiles(s);
       std::vector<std::string>::iterator i;
       for (i=s.begin();i!=s.end();++i) 
         {
           std::cout << *i << std::endl;
         }
       std::cout << "$$$$ "<<std::endl;

       //Puts images
       std::vector<vtkImageData*> images;
	   w.GetSelectedImages(images,3);

// images[1]->UpdateInformation();
	/*   vtkMetaImageReader *r= vtkMetaImageReader::New();
		   r->SetFileName("c:\\toto.mhd");
	   double zz[3];
		 images[0]->GetSpacing(zz);

	   vtkMetaImageWriter* ww = vtkMetaImageWriter::New(); 
	   	 ww->SetFileName("c:\\toto2.mhd"); 
		 ww->SetInput(images[0]);
		 ww->GetInput()->ShallowCopy(images[0]);
		 ww->UpdateInformation();
		 ww->GetInput()->GetSpacing(zz);
		 

//>GetImageDataInput(0)->GetSpacing(zz);
	 images[0]->Delete();
	
    ww->Write(); 
   ww->Delete();
*/



       //w.GetSelectedImages(images,output_dim);
       std::cout<<images.size()<<std::endl;

       crea::VtkBasicSlicer(images.front());
       images.front()->Delete();
       w.OnExit();

     }
   else if (w.GetReturnCode() == wxID_CANCEL)
     {
		
       w.OnExit();
       std::cout << "$$$$ main : user clicked 'CANCEL' $$$$"<<std::endl;
     }
   else 
     {
       w.OnExit();
       std::cout << "$$$$ main : dialog ended without return code ! $$$$"
                 <<std::endl;    
     }


   //   std::cout << "$$$$ main : deleting dialog"<<std::endl;
   //   delete w;
   std::cout << "$$$$$$$$$$$$$$$$$$$$ main ended "<<std::endl;
   return false;
}


