#include <creaImageIOTreeLevelDescriptor.h>
#include <creaImageIOSystem.h>


namespace creaImageIO
{
  namespace tree
  {
    /// Adds the AttributeDescriptor to the list
    void LevelDescriptor::Add(const AttributeDescriptor& a)
    {
      GimmickMessage(5,"Adding Attribute Descriptor '"<<a.GetKey()
		     <<"' to LevelDescriptor"
		     <<std::endl);
      mAttributeDescriptorList.push_back(a);
      if ( a.GetFlags() & AttributeDescriptor::IDENTIFIER )
	{
	  GimmickMessage(6,"Is an IDENTIFIER"<<std::endl);
	  mIdentifierList.push_back(a.GetKey());
	}
      if ( a.GetFlags() & AttributeDescriptor::LABEL )
	{
	  GimmickMessage(6,"Is a LABEL"<<std::endl);
	  mLabelList.push_back(a.GetKey());
	}
    }

	

  }
}

